Bug 1118707 - VMstate static checker: backport -dump-vmstate feature to export json-encoded vmstate info
Summary: VMstate static checker: backport -dump-vmstate feature to export json-encoded...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 7
Classification: Red Hat
Component: qemu-kvm
Version: 7.1
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: rc
: ---
Assignee: Amit Shah
QA Contact: Virtualization Bugs
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2014-07-11 09:46 UTC by Amit Shah
Modified: 2015-03-05 08:10 UTC (History)
9 users (show)

Fixed In Version: qemu-kvm-1.5.3-67.el7
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2015-03-05 08:10:45 UTC
Target Upstream Version:


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2015:0349 normal SHIPPED_LIVE Important: qemu-kvm security, bug fix, and enhancement update 2015-03-05 12:27:34 UTC

Description Amit Shah 2014-07-11 09:46:54 UTC
Description of problem:

The static checker is merged usptream; backport it for 7.1.

This will be useful to get vmstate json output and check for migration compatibility between various versions of qemu.

Syntax is:

qemu-kvm -dump-vmstate -M <machine type> -dump-vmstate <filename>


Later, from the qemu sources,

./scripts/vmstate-static-checker.py -s src.json -d dest.json

will output any migration-breaking changes introduced in dest.json as compared with src.json.

Comment 2 Amit Shah 2014-07-11 09:51:06 UTC
More info on invocation from upstream commit messages:

For qemu:

    migration: dump vmstate info as a json file for static analysis
    
    This commit adds a new command, '-dump-vmstate', that takes a filename
    as an argument.  When executed, QEMU will dump the vmstate information
    for the machine type it's invoked with to the file, and quit.
    
    The JSON-format output can then be used to compare the vmstate info for
    different QEMU versions, specifically to test whether live migration
    would break due to changes in the vmstate data.
    
    A Python script that compares the output of such JSON dumps is included
    in the following commit.

and the script:

    vmstate-static-checker: script to validate vmstate changes
    
    This script compares the vmstate dumps in JSON format as output by QEMU
    with the -dump-vmstate option.
    
    It flags various errors, like version mismatch, sections going away,
    size mismatches, etc.
    
    This script is tolerant of a few changes that do not change the on-wire
    format, like embedding a few fields within substructs.
    
    The script takes -s/--src and -d/--dest parameters, to which filenames
    are given as arguments.
    
    Example:
    
    (in a qemu 2.0 tree):
    ./x86_64-softmmu/qemu-system-x86_64 -dump-vmstate qemu-2.0.json
    
    (in a qemu 2.2 tree:)
    ./x86_64-softmmu/qemu-system-x86_64 -dump-vmstate -M pc-i440fx-2.0 \
       qemu-2.2-m2.0.json
    
    ./scripts/vmstate-static-checker.py -s qemu-2.0.json -d qemu-2.2-m2.0.json
    
    The script also takes a --reverse parameter to switch the src and dest
    jsons.  This is just a shorthand for reversing the src and dest.
    
    The --help parameter shows usage information.

Comment 4 Jeff Nelson 2014-08-08 16:54:52 UTC
Fix included in qemu-kvm-1.5.3-67.el7

Comment 6 Shaolong Hu 2014-10-13 09:17:35 UTC
Verified on qemu-kvm-rhev-2.1.2-3.el7.x86_64:


# /usr/libexec/qemu-kvm -M pc-q35-rhel7.1.0 -dump-vmstate pc-q35-rhel7.1.0

# cat pc-q35-rhel7.1.0 | head -n 20
{
  "vmschkmachine": {
    "Name": "pc-q35-rhel7.1.0"
  },
  "usb-host": {
    "Name": "usb-host",
    "version_id": 1,
    "minimum_version_id": 1,
    "Description": {
      "name": "usb-host",
      "version_id": 1,
      "minimum_version_id": 1,
      "Fields": [
        {
          "field": "parent_obj",
          "version_id": 0,
          "field_exists": false,
          "size": 5808,
          "Description": {
            "name": "USBDevice",
...


Verified on qemu-kvm-1.5.3-75.el7.x86_64:

# /usr/libexec/qemu-kvm -M pc-q35-rhel7.0.0 -dump-vmstate pc-q35-rhel7.0.0

# cat pc-q35-rhel7.0.0 | head -n 20
{
  "vmschkmachine": {
    "Name": "pc-q35-rhel7.0.0"
  },
  "port92": {
    "Name": "port92",
    "version_id": 1,
    "minimum_version_id": 1,
    "Description": {
      "name": "port92",
      "version_id": 1,
      "minimum_version_id": 1,
      "Fields": [
        {
          "field": "outport",
          "version_id": 0,
          "field_exists": false,
          "size": 1
        }
      ]

Comment 8 errata-xmlrpc 2015-03-05 08:10:45 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://rhn.redhat.com/errata/RHSA-2015-0349.html


Note You need to log in before you can comment on or make changes to this bug.